## scotch 7.0.3

=== CMakeLists.txt ===
## Copyright 2014-2016,2021-2023 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                                                        ##
##   FUNCTION   : Top-level CMake configuration file      ##
##                                                        ##
##   DATES      : # Version 7.0  : from : 18 jan 2022     ##
##                                 to     16 jan 2023     ##
##                                                        ##
############################################################

project(SCOTCH)
cmake_minimum_required(VERSION 3.10)
enable_language(C Fortran)

# Add module directory
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

set(SCOTCH_VERSION 7)
set(SCOTCH_RELEASE 0)
set(SCOTCH_PATCHLEVEL 3)
set(SCOTCH_CODENAME "Sankara")

add_definitions(-DSCOTCH_VERSION_NUM=${SCOTCH_VERSION}
  -DSCOTCH_RELEASE_NUM=${SCOTCH_RELEASE}
  -DSCOTCH_PATCHLEVEL_NUM=${SCOTCH_PATCHLEVEL})

set(SCOTCH_VERSION_LONG "${SCOTCH_VERSION}.${SCOTCH_RELEASE}.${SCOTCH_PATCHLEVEL}")

# Set integer size: by default, use compiler int size
set(INTSIZE "" CACHE STRING "Integer size: empty string stands for C compiler int type size")

# Thread support
option(THREADS "Use multi-threading in Scotch and PT-Scotch" ON)

# Use MPI with threads
option(MPI_THREAD_MULTIPLE "Use multi-threading with MPI in PT-Scotch" ON)

# Build PT-Scotch
option(BUILD_PTSCOTCH "Build PT-Scotch" ON)

# Build libESMUMPS
option(BUILD_LIBESMUMPS "Build EsMUMPS library" ON)

# Build libScotchMeTiS
option(BUILD_LIBSCOTCHMETIS "Build ScotchMeTiS library" ON)

# Install our MeTiS header stubs
option(INSTALL_METIS_HEADERS "Install libScotchMeTiS headers in destination directory" ON)

# Compression format options
option(USE_ZLIB "Use ZLIB compression format if found" ON)
option(USE_LZMA "Use LZMA compression format if found" ON)
option(USE_BZ2 "Use BZ2 compression format if found" ON)

# Set fPIC flag when building shared libraries
set(CMAKE_POSITION_INDEPENDENT_CODE ${BUILD_SHARED_LIBS})

# Allow for testing
enable_testing()

add_subdirectory(src)

# Install man pages
install(DIRECTORY man/man1 DESTINATION man FILES_MATCHING PATTERN "*.1")

=== src/Makefile ===
## Copyright 2004,2007,2008,2010-2012,2014,2018-2020 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION	= 7
RELEASE = 0
PATCHLEVEL = 3
CODENAME = "Sankara"

.PHONY				:	clean	default	install	ptscotch	realclean	required	scotch

default				:	scotch

required			:	Makefile.inc	../bin	../include	../lib

Makefile.inc			:
					@echo "#####################################################################"
			        	@echo "BEFORE COMPILING Scotch OR PT-Scotch, YOU SHOULD HAVE AN APPROPRIATE"
					@echo "Makefile.inc FILE IN THIS DIRECTORY. PLEASE LOOK INTO DIRECTORY"
	        			@echo " ./Make.inc FOR AN EXISTING Makefile.inc FILE THAT FITS YOUR NEED, OR"
		        		@echo "USE THEM AS MODELS IN CASE YOU NEED TO BUILD A NEW ONE FOR YOUR"
		        		@echo "PARTICULAR PLATFORM."
			        	@echo "#####################################################################"
			        	@echo "Then, type \"make scotch\" (default) for the sequential library"
			        	@echo "and software, or \"make ptscotch\" for the parallel library and"
			        	@echo "software."
					@exit 1

include Makefile.inc

prefix		?= /usr/local
bindir		?= $(prefix)/bin
includedir	?= $(prefix)/include
includestub     ?= include_stub
includestubdir	?= $(prefix)/$(includestub)
libdir		?= $(prefix)/lib
datarootdir	?= $(prefix)/share
mandir		?= $(datarootdir)/man

../bin				:
					-$(MKDIR) ../bin

../include			:
					-$(MKDIR) ../include

../lib				:
					-$(MKDIR) ../lib

$(bindir)			:
					-$(MKDIR) $(bindir)

$(datarootdir)			:
					-$(MKDIR) $(datarootdir)

$(includedir)			:
					-$(MKDIR) $(includedir)
					-$(MKDIR) $(includestubdir)

$(libdir)			:
					-$(MKDIR) $(libdir)

$(mandir)			:	$(datarootdir)
					-$(MKDIR) $(mandir)

$(mandir)/man1			:	$(mandir)
					-$(MKDIR) $(mandir)/man1

libscotch			:	required
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) scotch && $(MAKE) install)

scotch				:	libscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) CODENAME=$(CODENAME) scotch && $(MAKE) install)
					(cd libscotchmetis ; $(MAKE)                                                                scotch && $(MAKE) install)

libptscotch			:	libscotch
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) ptscotch && $(MAKE) ptinstall)

ptscotch			:	libptscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) CODENAME=$(CODENAME) ptscotch && $(MAKE) ptinstall)
					(cd libscotchmetis ; $(MAKE)                                                                ptscotch && $(MAKE) ptinstall)

check				:	scotch
					(cd check ; $(MAKE) check)

check_full			:	scotch
					(cd check ; $(MAKE) check_full)

ptcheck				:	ptscotch
					(cd check ; $(MAKE) ptcheck)

ptcheck_full			:	ptscotch
					(cd check ; $(MAKE) ptcheck_full)

esmumps				:	scotch
					(cd esmumps ; $(MAKE) scotch && $(MAKE) install)

escheck				:	esmumps
					(cd check ; $(MAKE) escheck)

ptesmumps			:	scotch	ptscotch
					(cd esmumps ; $(MAKE) ptscotch && $(MAKE) ptinstall)

install				:	required	$(bindir)	$(includedir)	$(libdir)	$(mandir)/man1
					-$(CP) -f ../bin/[agm]*$(EXE) $(bindir)
					-$(CP) -f ../bin/d[agm]*$(EXE) $(bindir)
					-$(CP) -f ../include/*esmumps*.h $(includedir)
					-$(CP) -f ../include/*scotch*.h $(includedir)
					-$(CP) -f ../lib/*esmumps*$(LIB) $(libdir)
					-$(CP) -f ../lib/*scotch*$(LIB) $(libdir)
					-$(CP) -f ../man/man1/*[.]1 $(mandir)/man1

installstub			:	required	$(includedir)
					-$(CP) -f ../include/*metis*.h $(includestubdir)

clean				:	required
					(cd libscotch ;      $(MAKE) clean)
					(cd scotch ;         $(MAKE) clean)
					(cd libscotchmetis ; $(MAKE) clean)
					(cd check ;          $(MAKE) clean)
					(cd esmumps ;        $(MAKE) clean)

realclean			:	required
					(cd libscotch ;      $(MAKE) realclean)
					(cd scotch ;         $(MAKE) realclean)
					(cd libscotchmetis ; $(MAKE) realclean)
					(cd check ;          $(MAKE) realclean)
					(cd esmumps ;        $(MAKE) realclean)
					-$(RM) ../bin/* ../include/* ../lib/*

=== src/check/CMakeLists.txt ===
## Copyright 2014-2016,2021,2022 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Marc FUENTES                            ##
##                Florent PRUVOST                         ##
##                Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     26 jan 2023     ##
##                                                        ##
############################################################

# Set directory aliases
set(dat ${CMAKE_CURRENT_SOURCE_DIR}/data)
set(tgt ${PROJECT_SOURCE_DIR}/tgt)

# Macro to add quickly a Scotch test executable
function(add_test_scotch)
  add_executable(${ARGV0} ${ARGV0}.c)
  set_target_properties(${ARGV0} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(${ARGV0} scotch scotcherr)
  if(${ARGC} GREATER_EQUAL 2)
    add_test(NAME ${ARGV0} COMMAND ${ARGV0})
  endif()
endfunction(add_test_scotch)

# Bash needed for running some tests
include(FindUnixCommands)

# Define an alias for /dev/null on Windows-like systems
if (MINGW OR MSYS OR WIN32)
  set(dev_null NUL)
else(MINGW OR MSYS OR WIN32)
  set(dev_null /dev/null)
endif(MINGW OR MSYS OR WIN32)

#######################################
#  Tests of the sequential libraries  #
#######################################

# test_common_file_compress
add_test_scotch(test_common_file_compress)
set(_map_bz2 "BZIP2")
set(_map_gz "ZLIB")
set(_map_lzma "LIBLZMA")
foreach(ext "bz2" "gz" "lzma")
  if(${_map_${ext}}_FOUND)
    set(cur ${CMAKE_CURRENT_BINARY_DIR})
    set(src_cur ${CMAKE_CURRENT_SOURCE_DIR})
    add_test(NAME test_common_file_compress_${ext} COMMAND ${BASH} -c
      "${CMAKE_COMMAND} -E copy ${src_cur}/data/bump_b1.grf ${cur}/bump_b1.grf && \
      $<TARGET_FILE:test_common_file_compress> ${cur}/bump_b1.grf ${cur}/bump_b1.grf.${ext} && \
      $<TARGET_FILE:test_common_file_compress> ${cur}/bump_b1.grf.${ext} ${cur}/bump_b1.grf && \
      ${CMAKE_COMMAND} -E compare_files ${cur}/bump_b1.grf ${src_cur}/data/bump_b1.grf")
  endif(${_map_${ext}}_FOUND)
endforeach()

# test_common_random
add_test_scotch(test_common_random)
add_test(NAME test_common_random_0 COMMAND test_common_random ${CMAKE_CURRENT_BINARY_DIR}/rand.dat 0)
add_test(NAME test_common_random_1 COMMAND test_common_random ${CMAKE_CURRENT_BINARY_DIR}/rand.dat 1)

# test_common_thread
add_test_scotch(test_common_thread 1)

# test_fibo
add_test_scotch(test_fibo 1)

# Test EsMumps
if(BUILD_LIBESMUMPS)
  add_executable(test_libesmumps test_libesmumps.c)
  add_dependencies(test_libesmumps esmumps_h)
  set_target_properties(test_libesmumps PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_include_directories(test_libesmumps PRIVATE ${GENERATED_INCLUDE_DIR})
  target_link_libraries(test_libesmumps scotch esmumps scotcherr)
  add_test(NAME test_libesmumps_1 COMMAND $<TARGET_FILE:test_libesmumps> ${dat}/bump.grf)
  add_test(NAME test_libesmumps_2 COMMAND $<TARGET_FILE:test_libesmumps> ${dat}/bump_imbal_32.grf)
endif(BUILD_LIBESMUMPS)

# Test libScotchMeTiS
if(BUILD_LIBSCOTCHMETIS)
  foreach(version 3 5)
    add_executable(test_libmetisv${version} test_libmetis.c)
    set_target_properties(test_libmetisv${version} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    target_compile_definitions(test_libmetisv${version} PRIVATE SCOTCH_METIS_VERSION=${version})
    target_include_directories(test_libmetisv${version} PRIVATE ${GENERATED_INCLUDE_DIR})
    target_link_libraries(test_libmetisv${version} scotchmetisv${version} scotch scotcherr)

    add_test(NAME test_libmetisv${version}_1 COMMAND $<TARGET_FILE:test_libmetisv${version}> ${dat}/bump.grf)
    add_test(NAME test_libmetisv${version}_2 COMMAND $<TARGET_FILE:test_libmetisv${version}> ${dat}/bump_b1.grf)
    add_test(NAME test_libmetisv${version}_3 COMMAND $<TARGET_FILE:test_libmetisv${version}> ${dat}/bump_imbal_32.grf)

    add_executable(test_libmetis_dualv${version} test_libmetis_dual.c)
    target_compile_definitions(test_libmetis_dualv${version} PRIVATE SCOTCH_METIS_VERSION=${version})
    target_include_directories(test_libmetis_dualv${version} PRIVATE ${GENERATED_INCLUDE_DIR})
    target_link_libraries(test_libmetis_dualv${version} scotchmetisv${version} scotch scotcherr)
    add_test(NAME test_libmetis_dualv${version} COMMAND test_libmetis_dualv${version})
    if(${CMAKE_Fortran_COMPILER_SUPPORTS_F90}) # Safeguard to avoid x77 compilers
      add_executable(test_libmetis_dual_f_v${version} test_libmetis_dual_f.f90)
      target_compile_definitions(test_libmetis_dual_f_v${version} PRIVATE SCOTCH_METIS_VERSION=${version})
      target_include_directories(test_libmetis_dual_f_v${version} PRIVATE ${GENERATED_INCLUDE_DIR})
      target_link_libraries(test_libmetis_dual_f_v${version} scotch scotchmetisv${version} scotcherr)
      add_test(NAME test_libmetis_dual_f_v${version} COMMAND test_libmetis_dual_f_v${version})
    endif()
  endforeach(version 3 5)
endif(BUILD_LIBSCOTCHMETIS)

# test_scotch_arch
add_test_scotch(test_scotch_arch)
add_test(NAME test_scotch_arch COMMAND test_scotch_arch  arch.tgt)

# test_scotch_arch_deco
add_test_scotch(test_scotch_arch_deco)
set(cur_src ${CMAKE_CURRENT_SOURCE_DIR})
add_test(NAME test_scotch_arch_deco COMMAND test_scotch_arch_deco ${cur_src}/data/m4x4.grf arch2.tgt)

# test_scotch_context
add_test_scotch(test_scotch_context)
add_test(NAME test_scotch_context COMMAND test_scotch_context ${cur_src}/data/bump_b1.grf)

# test_graph_coarsen
add_test_scotch(test_scotch_graph_coarsen)
add_test(NAME test_scotch_graph_coarsen_1 COMMAND test_scotch_graph_coarsen ${cur_src}/data/bump.grf)
add_test(NAME test_scotch_graph_coarsen_2 COMMAND test_scotch_graph_coarsen ${cur_src}/data/bump_b100000.grf)

# test_graph_color
add_test_scotch(test_scotch_graph_color)
add_test(NAME test_scotch_graph_color_1 COMMAND test_scotch_graph_color ${cur_src}/data/bump.grf)
add_test(NAME test_scotch_graph_color_2 COMMAND test_scotch_graph_color ${cur_src}/data/bump_b100000.grf)

# test_graph_diam
add_test_scotch(test_scotch_graph_diam)
add_test(NAME test_scotch_graph_diam_1 COMMAND test_scotch_graph_diam ${cur_src}/data/bump.grf)
add_test(NAME test_scotch_graph_diam_2 COMMAND test_scotch_graph_diam ${cur_src}/data/m16x16_b1.grf)
add_test(NAME test_scotch_graph_diam_3 COMMAND test_scotch_graph_diam ${cur_src}/data/p2-p2.grf)
add_test(NAME test_scotch_graph_diam_4 COMMAND test_scotch_graph_diam ${cur_src}/data/bump_b100000.grf)

# test_graph_dump
#TODO

# test_graph_induce
add_test_scotch(test_scotch_graph_induce)
add_test(NAME test_scotch_graph_induce_1 COMMAND test_scotch_graph_induce ${cur_src}/data/bump.grf)
add_test(NAME test_scotch_graph_induce_2 COMMAND test_scotch_graph_induce ${cur_src}/data/bump_b100000.grf)

# test_scotch_graph_map
add_test_scotch(test_scotch_graph_map)
add_test(NAME test_scotch_graph_1 COMMAND test_scotch_graph_map ${cur_src}/data/m4x4.grf)
add_test(NAME test_scotch_graph_2 COMMAND test_scotch_graph_map ${cur_src}/data/m4x4_b1.grf)
add_test(NAME test_scotch_graph_3 COMMAND test_scotch_graph_map ${cur_src}/data/m16x16.grf)
add_test(NAME test_scotch_graph_4 COMMAND test_scotch_graph_map ${cur_src}/data/m16x16_b1.grf)

# test_scotch_graph_map_copy
add_test_scotch(test_scotch_graph_map_copy)
add_test(NAME test_scotch_graph_map_copy_1 COMMAND test_scotch_graph_map_copy ${cur_src}/data/bump.grf)
add_test(NAME test_scotch_graph_map_copy_2 COMMAND test_scotch_graph_map_copy ${cur_src}/data/bump_b100000.grf)

# test_scotch_graph_order
add_test_scotch(test_scotch_graph_order)
add_test(NAME test_scotch_graph_order_1 COMMAND test_scotch_graph_order ${cur_src}/data/bump.grf)
add_test(NAME test_scotch_graph_order_2 COMMAND test_scotch_graph_order ${cur_src}/data/bump_b100000.grf)

# test_scotch_graph_part_ovl
add_test_scotch(test_scotch_graph_part_ovl)
add_test(NAME test_scotch_graph_part_ovl_1 COMMAND test_scotch_graph_part_ovl 4 ${cur_src}/data/m16x16.grf ${dev_null})
add_test(NAME test_scotch_graph_part_ovl_2 COMMAND test_scotch_graph_part_ovl 4 ${cur_src}/data/m16x16_b1.grf ${dev_null})

# test_scotch_mesh_graph
add_test_scotch(test_scotch_mesh_graph)
add_test(NAME test_scotch_mesh_graph COMMAND test_scotch_mesh_graph  ${cur_src}/data/ship001.msh)

# test_strat_seq
add_test_scotch(test_strat_seq 1)

#####################################
#  Tests of the parallel libraries  #
#####################################

if(BUILD_PTSCOTCH)
  # Macro to add quickly a PT-Scotch test executable
  function(add_exec_ptscotch)
    add_executable(${ARGV0} ${ARGV0}.c)
    set_target_properties(${ARGV0} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries(${ARGV0} ptscotch ptscotcherr)
  endfunction(add_exec_ptscotch)

  function(add_test_ptscotch)
    set(args ${ARGV})
    list(REMOVE_AT args 0) # in place of POP_FRONT which is available only for cmake >3.15
    string(REGEX REPLACE "^(.+)/data/(.+)\\.grf$" "\\2" arg_ext ${args})
    add_test(NAME ${ARGV0}_${arg_ext} COMMAND ${MPIEXEC_EXECUTABLE} ${MPIEXEC_PREFLAGS} ${MPIEXEC_NUMPROC_FLAG} 3 $<TARGET_FILE:${ARGV0}> ${args})
  endfunction(add_test_ptscotch)

  # test_strat_par
  add_exec_ptscotch(test_strat_par)
  add_test(NAME test_strat_par COMMAND test_strat_par)

  # test_scotch_dgraph_band
  add_exec_ptscotch(test_scotch_dgraph_band)
  add_test_ptscotch(test_scotch_dgraph_band ${CMAKE_CURRENT_SOURCE_DIR}/data/bump.grf)
  add_test_ptscotch(test_scotch_dgraph_band ${CMAKE_CURRENT_SOURCE_DIR}/data/bump_b100000.grf)

  # test_scotch_dgraph_coarsen
  add_exec_ptscotch(test_scotch_dgraph_coarsen)
  add_test_ptscotch(test_scotch_dgraph_coarsen ${CMAKE_CURRENT_SOURCE_DIR}/data/bump.grf)
  add_test_ptscotch(test_scotch_dgraph_coarsen ${CMAKE_CURRENT_SOURCE_DIR}/data/bump_b100000.grf)
  add_test_ptscotch(test_scotch_dgraph_coarsen ${CMAKE_CURRENT_SOURCE_DIR}/data/m4x4_b1.grf)

=== src/check/Makefile ===
## Copyright 2011,2012,2014-2016,2018-2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

TMPDIR			= /tmp

SCOTCHBINDIR		= ../../bin
SCOTCHINCDIR		= ../../include
SCOTCHLIBDIR		= ../../lib
SCOTCHTGTDIR		= ../../tgt

LIBESMUMPS		= -lesmumps -lscotch -lscotcherr
LIBPTSCOTCH		= -lptscotch -lscotch -lptscotcherr
LIBSCOTCH		= -lscotch -lscotcherr

DEPESMUMPS		= $(SCOTCHLIBDIR)/libesmumps$(LIB)
DEPPTSCOTCH		= $(SCOTCHLIBDIR)/libptscotch$(LIB)
DEPSCOTCH		= $(SCOTCHLIBDIR)/libscotch$(LIB)

EXECPPROG		?= mpirun
EXECPFLAGS		?= $(if $(findstring Open,$(shell $(EXECPPROG) --version)),--oversubscribe)
# EXECPFLAGS		+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECS			?=
# EXECS			+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECP3			?= $(EXECPPROG) -n 3 $(EXECPFLAGS)
EXECP4			?= $(EXECPPROG) -n 4 $(EXECPFLAGS)

PROGDIFF		?= diff -q

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -I$(SCOTCHINCDIR) -c $(<) -o $(@)

%_v3$(EXE) :	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv3 $(SCOTCHLIBS) $(LDFLAGS)

%_v5$(EXE) :	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv5 $(SCOTCHLIBS) $(LDFLAGS)

%$(EXE)	:	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) $(SCOTCHLIBS) $(LDFLAGS)

%_v3$(EXE):	%.f90
				$(FC) $(FFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv3 $(SCOTCHLIBS) $(LDFLAGS)

%_v5$(EXE):	%.f90
				$(FC) $(FFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) -lscotchmetisv5 $(SCOTCHLIBS) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	check	ptcheck	clean	realclean

check				:	realclean
					$(MAKE) CC="$(CCS)" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" $(CHECKSCOTCH)

check_full			:	realclean
					$(MAKE) CC="$(CCS) -DSCOTCH_DEBUG_FULL" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" check_prog_full

ptcheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" $(CHECKPTSCOTCH)

ptcheck_full			:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" check_prog_dfull

escheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS)" CC="$(CCP)" SCOTCHLIBS="$(LIBESMUMPS)" $(CHECKESMUMPS)

clean				:
					-$(RM) *~ *$(OBJ)

realclean			:	clean
					-$(RM) 				\
					test_common_file_compress	\
					test_common_random		\
					test_common_thread		\
					test_fibo			\
					test_libesmumps			\
					test_libmetis_v3		\
					test_libmetis_v5		\
					test_libmetis_dual_v3		\
					test_libmetis_dual_v5		\
					test_libmetis_dual_f_v3		\
					test_libmetis_dual_f_v5		\
					test_scotch_arch		\
					test_scotch_arch_deco		\
					test_scotch_context		\
					test_scotch_graph_coarsen	\
					test_scotch_graph_color		\
					test_scotch_graph_diam		\
					test_scotch_graph_dump2		\
					test_scotch_graph_dump2.c	\
					test_scotch_graph_induce	\
					test_scotch_graph_map		\
					test_scotch_graph_map_copy	\
					test_scotch_graph_order		\
					test_scotch_graph_part_ovl	\
					test_scotch_dgraph_band		\
					test_scotch_dgraph_check	\
					test_scotch_dgraph_coarsen	\
					test_scotch_dgraph_grow		\
					test_scotch_dgraph_induce	\
					test_scotch_dgraph_redist	\
					test_scotch_mesh_graph		\
					test_strat_par			\
					test_strat_seq

##
##  Test cases dependencies.
##

CHECKSCOTCH = 		check_common_file_compress		\
			check_common_random			\
			check_common_thread			\
			check_fibo				\
			check_strat_seq				\
			check_scotch_arch			\
			check_scotch_arch_deco			\
			check_scotch_context			\
			check_scotch_graph_coarsen		\
			check_scotch_graph_color		\
			check_scotch_graph_diam			\
			check_scotch_graph_dump			\
			check_scotch_graph_induce		\
			check_scotch_graph_map			\
			check_scotch_graph_map_copy		\
			check_scotch_graph_order		\
			check_scotch_graph_part_ovl		\
			check_scotch_mesh_graph			\
			check_libmetis_v3			\
			check_libmetis_v5			\
			check_libmetis_dual_v3			\
			check_libmetis_dual_v5			\
			check_libmetis_dual_f_v3		\
			check_libmetis_dual_f_v5		\
			check_prog_amk				\
			check_prog_amk_grf			\
			check_prog_acpl				\
			check_prog_gbase			\
			check_prog_gmap				\
			check_prog_gmk				\
			check_prog_gmk_msh			\
			check_prog_gord				\
			check_prog_gord_block			\
			check_prog_gotst			\
			check_prog_gout				\
			check_prog_gpart			\
			check_prog_gpart_clustering		\
			check_prog_gpart_overlap		\
			check_prog_gpart_remap			\
			check_prog_gscat			\
			check_prog_gtst				\
			check_prog_mmk				\
			check_prog_mord

CHECKPTSCOTCH = 	check_strat_par				\
			check_scotch_dgraph_check		\
			check_scotch_dgraph_band		\
			check_scotch_dgraph_coarsen		\
			check_scotch_dgraph_grow		\
			check_scotch_dgraph_induce      	\
			check_scotch_dgraph_redist		\
			check_prog_dgord			\
			check_prog_dgpart			\
			check_prog_dgscat-dggath		\
			check_prog_dgtst

CHECKESMUMPS = 		check_libesmumps

##
##  Sequential library tests.
##

check_common_file_compress	:	test_common_file_compress
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.gz"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.gz" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.bz2"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.bz2" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.lzma"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.lzma" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"

test_common_file_compress	:	test_common_file_compress.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_random		:	test_common_random
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 0
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 1

test_common_random		:	test_common_random.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_thread		:	test_common_thread
					$(EXECS) ./test_common_thread

test_common_thread		:	test_common_thread.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_fibo			:	test_fibo
					$(EXECS) ./test_fibo

test_fibo			:	test_fibo.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_libesmumps		:	test_libesmumps
					$(EXECS) ./test_libesmumps data/bump.grf
					$(EXECS) ./test_libesmumps data/bump_imbal_32.grf

test_libesmumps			:	test_libesmumps.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libesmumps$(LIB)

##

check_libmetis_v3		:	test_libmetis_v3
					$(EXECS) ./test_libmetis_v3 data/bump.grf
					$(EXECS) ./test_libmetis_v3 data/bump_b1.grf
					$(EXECS) ./test_libmetis_v3 data/bump_imbal_32.grf

test_libmetis_v3		:	test_libmetis.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_v5		:	test_libmetis_v5
					$(EXECS) ./test_libmetis_v5 data/bump.grf
					$(EXECS) ./test_libmetis_v5 data/bump_b1.grf
					$(EXECS) ./test_libmetis_v5 data/bump_imbal_32.grf

test_libmetis_v5		:	test_libmetis.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_libmetis_dual_v3		:	test_libmetis_dual_v3
					$(EXECS) ./test_libmetis_dual_v3
					$(EXECS) ./test_libmetis_dual_v3 1

test_libmetis_dual_v3		:	test_libmetis_dual.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_dual_v5		:	test_libmetis_dual_v5
					$(EXECS) ./test_libmetis_dual_v5
					$(EXECS) ./test_libmetis_dual_v5 1

test_libmetis_dual_v5		:	test_libmetis_dual.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_libmetis_dual_f_v3	:	test_libmetis_dual_f_v3
					$(EXECS) ./test_libmetis_dual_f_v3

test_libmetis_dual_f_v3		:	test_libmetis_dual_f.f90	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv3$(LIB)

check_libmetis_dual_f_v5	:	test_libmetis_dual_f_v5
					$(EXECS) ./test_libmetis_dual_f_v5

test_libmetis_dual_f_v5		:	test_libmetis_dual_f.f90	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetisv5$(LIB)

##

check_scotch_arch		:	test_scotch_arch
					$(EXECS) ./test_scotch_arch "$(TMPDIR)/arch.tgt"

test_scotch_arch		:	test_scotch_arch.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_arch_deco		:	test_scotch_arch_deco
					$(EXECS) ./test_scotch_arch_deco data/m4x4.grf "$(TMPDIR)/arch2.tgt"
#					$(EXECS) ./test_scotch_arch_deco data/m4x4_b100000.grf "$(TMPDIR)/arch2.tgt"

test_scotch_arch_deco		:	test_scotch_arch_deco.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_context		:	test_scotch_context
					$(EXECS) ./test_scotch_context data/bump_b1.grf

test_scotch_context		:	test_scotch_context.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_coarsen	:	test_scotch_graph_coarsen
					$(EXECS) ./test_scotch_graph_coarsen data/bump.grf
					$(EXECS) ./test_scotch_graph_coarsen data/bump_b100000.grf

test_scotch_graph_coarsen	:	test_scotch_graph_coarsen.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_color	:	test_scotch_graph_color
					$(EXECS) ./test_scotch_graph_color data/bump.grf
					$(EXECS) ./test_scotch_graph_color data/bump_b100000.grf

test_scotch_graph_color		:	test_scotch_graph_color.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_diam		:	test_scotch_graph_diam
					$(EXECS) ./test_scotch_graph_diam data/bump_b100000.grf
					$(EXECS) ./test_scotch_graph_diam data/m16x16_b100000.grf
					$(EXECS) ./test_scotch_graph_diam data/p2-p2.grf

test_scotch_graph_diam		:	test_scotch_graph_diam.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_dump		:	test_scotch_graph_dump2
					$(EXECS) ./test_scotch_graph_dump2 $(TMPDIR)/m16x16_b1.grf
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"

test_scotch_graph_dump2		:	test_scotch_graph_dump2.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

test_scotch_graph_dump2.c	:	test_scotch_graph_dump.c

=== src/esmumps/CMakeLists.txt ===
## Copyright 2014-2016,2021,2022 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                Francois PELLEGRINI                     ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     21 apr 2022     ##
##                # Version 7.1  : from : 11 dec 2022     ##
##                                 to     11 dec 2022     ##
##                                                        ##
############################################################

set_source_files_properties(${GENERATED_INCLUDE_DIR}/scotch.h PROPERTIES GENERATED 1)

################
#  libEsMUMPS  #
################

# esmumps.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/esmumps.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library.h ${GENERATED_INCLUDE_DIR}/esmumps.h
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/library.h
  COMMENT "Copy esmumps.h to include directory")

add_custom_target(esmumps_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/esmumps.h")

# libEsMUMPS
set(esmumps_src
  dof.c
  esmumps.c
  graph_graph.c
  library_esmumps.c
  library_esmumps_f.c
  library_esmumps_strats.c
  order.c
  order_check.c
  order_io.c
  order_scotch_graph.c
  symbol.c
  symbol_check.c
  symbol_cost.c
  symbol_fax_graph.c
  symbol_fax.c)

set(esmumps_headers
  module.h
  library.h
  ${GENERATED_INCLUDE_DIR}/scotch.h
  ${LIBSCOTCH_INCLUDE_DIR}/common.h
  graph.h
  dof.h
  symbol.h
  order.h
  fax.h
  ${GENERATED_INCLUDE_DIR}/esmumps.h)

add_library(esmumps ${esmumps_src} ${esmumps_headers})
set_target_properties(esmumps PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/esmumps.h")

if(APPLE)
  set_target_properties(esmumps PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
endif(APPLE)

target_include_directories(esmumps PRIVATE
  $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
  $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
  $<INSTALL_INTERFACE:include>)

target_link_libraries(esmumps PRIVATE scotch)

add_dependencies(esmumps scotch_h)

add_executable(test_esmumps test_esmumps.c)
set_target_properties(test_esmumps PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(test_esmumps PRIVATE ${GENERATED_INCLUDE_DIR}/)
target_link_libraries(test_esmumps PRIVATE esmumps scotch scotcherrexit)
add_dependencies(test_esmumps scotch_h)

add_executable(test_fax test_fax.c)
set_target_properties(test_fax PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(test_fax PRIVATE ${GENERATED_INCLUDE_DIR}/)
target_link_libraries(test_fax PRIVATE esmumps scotch scotcherrexit)
add_dependencies(test_fax scotch_h)

# libEsMUMPS targets install
install(EXPORT esmumpsTargets
  FILE esmumpsTargets.cmake
  NAMESPACE SCOTCH::
  DESTINATION lib/cmake/scotch)

install(TARGETS esmumps
  EXPORT esmumpsTargets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  PUBLIC_HEADER DESTINATION include)

# Dummy PTEsMUMPS library file
add_library(ptesmumps ${esmumps_src} ${esmumps_headers})

set_target_properties(ptesmumps PROPERTIES PUBLIC_HEADER "${GENERATED_INCLUDE_DIR}/esmumps.h")

target_include_directories(ptesmumps PRIVATE
  $<BUILD_INTERFACE:${LIBSCOTCH_INCLUDE_DIR}>
  $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
  $<INSTALL_INTERFACE:include>)

target_link_libraries(ptesmumps PRIVATE scotch)
add_dependencies(ptesmumps scotch_h)

# libptesmumps targets install
install(EXPORT ptesmumpsTargets
  FILE ptesmumpsTargets.cmake
  NAMESPACE SCOTCH::
  DESTINATION lib/cmake/scotch)

install(TARGETS ptesmumps
  EXPORT ptesmumpsTargets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  PUBLIC_HEADER DESTINATION include)

=== src/libscotch/CMakeLists.txt ===
## Copyright 2014-2016,2021-2023 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##
############################################################
##                                                        ##
##   AUTHORS    : Cedric LACHAT                           ##
##                Amaury JACQUES                          ##
##                Florent PRUVOST                         ##
##                Marc FUENTES                            ##
##                                                        ##
##   FUNCTION   : Secondary configuration file for CMake  ##
##                                                        ##
##   DATES      : # Version 6.0  : from : 01 sep 2014     ##
##                                 to     01 sep 2021     ##
##                # Version 7.0  : from : 01 sep 2021     ##
##                                 to     26 jan 2023     ##
##                                                        ##
############################################################

################
#  dummysizes  #
################

add_executable(dummysizes dummysizes.c)
set_target_properties(dummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
if(BUILD_PTSCOTCH)
  find_package(MPI COMPONENTS C)
  if(NOT MPI_C_FOUND)
    message(FATAL_ERROR "MPI required to compile PT-Scotch")
  endif()
  add_executable(ptdummysizes dummysizes.c)
  set_target_properties(ptdummysizes PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(ptdummysizes PRIVATE MPI::MPI_C)
  add_dependencies(ptdummysizes scotch_h)
  set_target_properties(ptdummysizes PROPERTIES
    COMPILE_FLAGS -DSCOTCH_PTSCOTCH)
endif(BUILD_PTSCOTCH)

##############
#  scotch.h  #
##############

# Generate scotch.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotch.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library.h ${GENERATED_INCLUDE_DIR}/scotch.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotch.h")
add_custom_target(scotch_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotch.h")

# Generate scotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/scotchf.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_f.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:dummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_f.h ${GENERATED_INCLUDE_DIR}/scotchf.h DEPENDS dummysizes
  DEPENDS library.h
  COMMENT "Generate scotchf.h")
add_custom_target(scotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/scotchf.h")

################
#  ptscotch.h  #
################

# Generate ptscotch.h
if(BUILD_PTSCOTCH)
  add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotch.h
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_pt.h ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND $<TARGET_FILE:ptdummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_pt.h ${GENERATED_INCLUDE_DIR}/ptscotch.h DEPENDS ptdummysizes
    DEPENDS library_pt.h scotch_h
    COMMENT "Generate ptscotch.h")
  add_custom_target(ptscotch_h
    DEPENDS ${GENERATED_INCLUDE_DIR}/ptscotch.h)

# Generate ptscotchf.h
add_custom_command(OUTPUT ${GENERATED_INCLUDE_DIR}/ptscotchf.h
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/library_pt_f.h ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $<TARGET_FILE:ptdummysizes> ${CMAKE_CURRENT_BINARY_DIR}/library_pt_f.h ${GENERATED_INCLUDE_DIR}/ptscotchf.h DEPENDS ptdummysizes
  DEPENDS library.h
  COMMENT "Generate ptscotchf.h")
add_custom_target(ptscotchf_h
  DEPENDS "${GENERATED_INCLUDE_DIR}/ptscotchf.h")
endif(BUILD_PTSCOTCH)

#################
#  parser_yy.c  #
#################

# Copy parser_yy.y to binary dir
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.y
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS parser_yy.y
  COMMENT "Copy parser_yy.y to CMake binary directory")
add_custom_target(parser_yy_y DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/parser_yy.y)

# Generate parser_yy.c using Bison
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h
  COMMAND ${BISON_EXECUTABLE} "-pscotchyy${SCOTCH_NAME_SUFFIX}" --defines="parser_ly.h" --output="parser_yy.c" parser_yy.y
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.y module.h common.h parser.h parser_yy.h
  COMMENT "Generate parser_yy.c and parser_ly.h using Bison")
add_custom_target(parser_yy_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_yy.c ${CMAKE_CURRENT_BINARY_DIR}/parser_ly.h)
add_dependencies(parser_yy_c parser_yy_y)

#################
#  parser_ll.c  #
#################

# Copy parser_ll.l to binary dir
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.l
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/parser_ll.l ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS parser_ll.l
  COMMENT "Copy parser_ll.l to CMake binary directory")
add_custom_target(parser_ll_l DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.l)

# Generate parser_ll.c using Flex
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c
  COMMAND ${FLEX_EXECUTABLE} "-Pscotchyy${SCOTCH_NAME_SUFFIX}"  "-oparser_ll.c" parser_ll.l
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.l module.h common.h parser.h parser_ll.h parser_ly.h
  COMMENT "Generate parser_ll.c using Flex")
add_custom_target(parser_ll_c DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/parser_ll.c)
add_dependencies(parser_ll_c parser_ll_l)

###############
#  libScotch  #
###############

set(SCOTCH_C_SOURCES
  arch.c
  arch.h
  arch_build.c
  arch_build.h
  arch_build2.c
  arch_build2.h
  arch_cmplt.c
  arch_cmplt.h
  arch_cmpltw.c
  arch_cmpltw.h
  arch_deco.c
  arch_deco.h
  arch_deco2.c
  arch_deco2.h
  arch_dist.c
  arch_dist.h
  arch_hcub.c
  arch_hcub.h
  arch_mesh.c
  arch_mesh.h
  arch_tleaf.c
  arch_tleaf.h
  arch_sub.c
  arch_sub.h
  arch_torus.c
  arch_torus.h
  arch_vcmplt.c
  arch_vcmplt.h
  arch_vhcub.c
  arch_vhcub.h
  bgraph.c
  bgraph.h
  bgraph_bipart_bd.c
  bgraph_bipart_bd.h
  bgraph_bipart_df.c
  bgraph_bipart_df.h
  bgraph_bipart_ex.c
  bgraph_bipart_ex.h
  bgraph_bipart_fm.c
  bgraph_bipart_fm.h
  bgraph_bipart_gg.c
  bgraph_bipart_gg.h
  bgraph_bipart_gp.c
  bgraph_bipart_gp.h
  bgraph_bipart_ml.c
  bgraph_bipart_ml.h
  bgraph_bipart_st.c
  bgraph_bipart_st.h
  bgraph_bipart_zr.c
  bgraph_bipart_zr.h
  bgraph_check.c
  bgraph_store.c
  common.c
  common.h
  common_context.c
  common_error.c
  common_file.c
  common_file.h
  common_file_compress.c
  common_file_compress.h
  common_file_decompress.c
  common_integer.c
  common_memory.c
  common_string.c
  common_stub.c
  common_thread.c
  common_thread_system.c
  common_thread_system.h
  common_values.c
  common_values.h
  context.c
  context.h
  fibo.c
  fibo.h
  gain.c
  gain.h
  geom.c
  geom.h
  graph.c
  graph.h
  graph_band.c
  graph_base.c
  graph_check.c
  graph_clone.c
  graph_coarsen.c
  graph_coarsen.h
  graph_diam.c
  graph_ielo.c
  library_graph_induce.c
  graph_induce.c
  graph_induce.h
  graph_io.c
  graph_io.h
  graph_io_chac.c
  graph_io_habo.c
  graph_io_habo.h
  graph_io_mmkt.c
  graph_io_mmkt.h
  graph_io_scot.c
  graph_io_scot.h
  graph_list.c
  graph_list.h
  graph_match.c
  graph_match.h
  hall_order_hd.c
  hall_order_hd.h
  hall_order_hf.c
  hall_order_hf.h
  hall_order_hx.c
  hall_order_hx.h
  hgraph.c
  hgraph.h
  hgraph_check.c
  hgraph_induce.c
  hgraph_induce.h
  hgraph_order_bl.c
  hgraph_order_bl.h
  hgraph_order_cc.c
  hgraph_order_cc.h
  hgraph_order_cp.c
  hgraph_order_cp.h
  hgraph_order_gp.c
  hgraph_order_gp.h
  hgraph_order_hd.c
  hgraph_order_hd.h
  hgraph_order_hf.c
  hgraph_order_hf.h
  hgraph_order_hx.c
  hgraph_order_hx.h
  hgraph_order_kp.c
  hgraph_order_kp.h
  hgraph_order_nd.c
  hgraph_order_nd.h
  hgraph_order_si.c
  hgraph_order_si.h
  hgraph_order_st.c
  hgraph_order_st.h
  hmesh.c
  hmesh.h
  hmesh_check.c
  hmesh_hgraph.c
  hmesh_hgraph.h
  hmesh_induce.c
  hmesh_mesh.c
  hmesh_order_bl.c
  hmesh_order_bl.h
  hmesh_order_cp.c
  hmesh_order_cp.h
  hmesh_order_gp.c
  hmesh_order_gp.h
  hmesh_order_gr.c
  hmesh_order_gr.h
  hmesh_order_hd.c
  hmesh_order_hd.h
  hmesh_order_hf.c
  hmesh_order_hf.h
  hmesh_order_hx.c
  hmesh_order_hx.h
  hmesh_order_nd.c
  hmesh_order_nd.h
  hmesh_order_si.c
  hmesh_order_si.h
  hmesh_order_st.c
  hmesh_order_st.h
  kgraph.c
  kgraph.h
  kgraph_band.c
  kgraph_check.c
  kgraph_map_bd.c
  kgraph_map_bd.h
  kgraph_map_cp.c
  kgraph_map_cp.h
  kgraph_map_df.c
  kgraph_map_df.h
  kgraph_map_ex.c
  kgraph_map_ex.h
  kgraph_map_fm.c
  kgraph_map_fm.h
  kgraph_map_ml.c
  kgraph_map_ml.h
  kgraph_map_rb.c
  kgraph_map_rb.h
  kgraph_map_rb_map.c
  kgraph_map_rb_map.h
  kgraph_map_rb_part.c
  kgraph_map_rb_part.h
  kgraph_map_st.c
  kgraph_map_st.h
  kgraph_store.c
  library.h
  library_arch.c
  library_arch_build.c
  library_arch_build_f.c
  library_arch_dom.c
  library_arch_dom_f.c
  library_arch_f.c
  library_common_f.c
  library_context.c
  library_context_graph.c
  library_context_graph_f.c
  #library_errcom.c
  #library_error.c
  #library_error_exit.c
  library_f.h
  library_geom.c
  library_geom_f.c
  library_graph.c
  library_graph_base.c
  library_graph_base_f.c
  library_graph_check.c
  library_graph_check_f.c
  library_graph_coarsen.c
  library_graph_coarsen_f.c
  library_graph_color.c
  library_graph_color_f.c
  library_graph_diam.c
  library_graph_diam_f.c
  library_graph_f.c
  library_graph_io_chac.c
  library_graph_io_chac_f.c
  library_graph_io_habo.c
  library_graph_io_habo_f.c
  library_graph_io_mmkt.c
  library_graph_io_mmkt_f.c
  library_graph_io_scot.c
  library_graph_io_scot_f.c
  library_graph_map.c
  library_graph_map_f.c
  library_graph_map_io.c
  library_graph_map_io.h
  library_graph_map_io_f.c
  library_graph_map_view.c
  library_graph_map_view.h
  library_graph_map_view_f.c
  library_graph_order.c
  library_graph_order_f.c
  library_graph_part_ovl.c
  library_graph_part_ovl_f.c
  library_mapping.c
  library_mapping.h
  library_memory.c
  library_mesh.c
  library_mesh_f.c
  library_mesh_graph.c
  library_mesh_graph_f.c
  library_mesh_io_habo.c
  library_mesh_io_habo_f.c
  library_mesh_io_scot.c
  library_mesh_io_scot_f.c
  library_mesh_order.c
  library_mesh_order_f.c
  library_order.c
  library_order.h
  library_parser.c
  library_parser_f.c
  library_pt.h

=== src/scotch/Makefile ===
## Copyright 2004,2007-2012,2019 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

bindir		= ../../bin
includedir	= ../../include
libdir		= ../../lib

ifeq ($(strip $(CODENAME)),)
CODENAMEDEF	=
else
CODENAMEDEF	= "-DSCOTCH_CODENAME=\"$(CODENAME)\""
endif

##
##  General inference rules.
##

include ../Makefile.inc

%$(EXE)	:	%$(OBJ)
		 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -o $(@) -L$(libdir) -l$(SCOTCHLIB) -lscotch -l$(SCOTCHLIB)errexit $(LDFLAGS)

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(CODENAMEDEF) -c $(<) -o $(@)

%$(EXE)	:	%.c
				$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(CODENAMEDEF) $(<) -o $(@) -L$(libdir) -l$(SCOTCHLIB) -lscotch -l$(SCOTCHLIB)errexit $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) CC="$(CCS)" SCOTCHLIB=scotch	\
					acpl$(EXE)				\
					amk_ccc$(EXE)				\
					amk_fft2$(EXE)				\
					amk_grf$(EXE)				\
					amk_hy$(EXE)				\
					amk_m2$(EXE)				\
					amk_p2$(EXE)				\
					atst$(EXE)				\
					gbase$(EXE)				\
					gcv$(EXE)				\
					gdump$(EXE)				\
					gmap$(EXE)				\
					gmk_hy$(EXE)				\
					gmk_m2$(EXE)				\
					gmk_m3$(EXE)				\
					gmk_msh$(EXE)				\
					gmk_ub2$(EXE)				\
					gmtst$(EXE)				\
					gord$(EXE)				\
					gotst$(EXE)				\
					gout$(EXE)				\
					gpart$(EXE)				\
					gscat$(EXE)				\
					gtst$(EXE)				\
					mcv$(EXE)				\
					mmk_m2$(EXE)				\
					mmk_m3$(EXE)				\
					mord$(EXE)				\
					mtst$(EXE)

ptscotch			:
					$(MAKE) CC="$(CCP)" SCOTCHLIB=ptscotch	\
					dggath$(EXE)				\
					dgmap$(EXE)				\
					dgord$(EXE)				\
					dgpart$(EXE)				\
					dgscat$(EXE)				\
					dgtst$(EXE)

install				:	scotch
					-$(CP) acpl$(EXE) amk_ccc$(EXE) amk_fft2$(EXE) amk_grf$(EXE) amk_hy$(EXE) amk_m2$(EXE) amk_p2$(EXE) atst$(EXE) gbase$(EXE) gcv$(EXE) gdump$(EXE) gmap$(EXE) gmk_hy$(EXE) gmk_m2$(EXE) gmk_m3$(EXE) gmk_msh$(EXE) gmk_ub2$(EXE) gmtst$(EXE) gord$(EXE) gotst$(EXE) gout$(EXE) gpart$(EXE) *gtst$(EXE) gscat$(EXE) mcv$(EXE) mmk_m2$(EXE) mmk_m3$(EXE) mord$(EXE) mtst$(EXE) $(bindir)

ptinstall			:	ptscotch
					-$(CP) dggath$(EXE) dgmap$(EXE) dgord$(EXE) dgpart$(EXE) dgscat$(EXE) dgtst$(EXE) $(bindir)

clean				:
					-$(RM) *~ *$(OBJ) acpl$(EXE) amk_ccc$(EXE) amk_fft2$(EXE) amk_grf$(EXE) amk_hy$(EXE) amk_m2$(EXE) amk_p2$(EXE) atst$(EXE) gbase$(EXE) gcv$(EXE) gdump$(EXE) *ggath$(EXE) *gmap$(EXE) gmk_hy$(EXE) gmk_m2$(EXE) gmk_m3$(EXE) gmk_msh$(EXE) gmk_ub2$(EXE) gmtst$(EXE) *gord$(EXE) gotst$(EXE) gout$(EXE) *gpart$(EXE) *gscat$(EXE) *gtst$(EXE) mcv$(EXE) mmk_m2$(EXE) mmk_m3$(EXE) mord$(EXE) mtst$(EXE)

realclean			:	clean

##
##  Todo list.
##

acpl$(EXE)			:	acpl.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					acpl.h

amk_ccc$(EXE)			:	amk_ccc.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_ccc.h

amk_fft2$(EXE)			:	amk_fft2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_fft2.h

amk_grf$(EXE)			:	amk_grf.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_grf.h

amk_hy$(EXE)			:	amk_hy.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_hy.h

amk_m2$(EXE)			:	amk_m2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_m2.h

amk_p2$(EXE)			:	amk_p2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_p2.h

atst$(EXE)			:	atst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					atst.h

dggath$(EXE)			:	dggath.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dggath.h

dgmap$(EXE)			:	dgmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgmap.h

dgord$(EXE)			:	dgord.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgord.h

dgpart$(EXE)			:	dgmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgmap.h
			 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -DSCOTCH_COMPILE_PART -o $(@) -L$(libdir) -lptscotch -lscotch -lptscotcherrexit $(LDFLAGS)

dgscat$(EXE)			:	dgscat.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgscat.h

dgtst$(EXE)			:	dgtst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgtst.h

gbase$(EXE)			:	gbase.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gbase.h

gcv$(EXE)			:	gcv.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gcv.h

gdump$(EXE)			:	gdump.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gdump.h

gmap$(EXE)			:	gmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmap.h

gmk_hy$(EXE)			:	gmk_hy.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_hy.h

gmk_m2$(EXE)			:	gmk_m2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_m2.h

gmk_m3$(EXE)			:	gmk_m3.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_m3.h

gmk_msh$(EXE)			:	gmk_msh.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_msh.h

gmk_ub2$(EXE)			:	gmk_ub2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_ub2.h

gmtst$(EXE)			:	gmtst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmtst.h

gord$(EXE)			:	gord.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gord.h

gotst$(EXE)			:	gotst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gotst.h

gout$(EXE)			:	gout_c.c				\
					gout_o.c				\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)
					$(CC) $(CFLAGS) -I../libscotch -I$(includedir) gout_c.c gout_o.c -o $(@) -L$(libdir) -lscotch -lscotcherrexit $(LDFLAGS)

gpart$(EXE)			:	gmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmap.h
			 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -DSCOTCH_COMPILE_PART -o $(@) -L$(libdir) -lscotch -lscotcherrexit $(LDFLAGS)

gscat$(EXE)			:	gscat.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gscat.h

gtst$(EXE)			:	gtst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gtst.h

mcv$(EXE)			:	mcv.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					mcv.h

mmk_m2$(EXE)			:	mmk_m2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					mmk_m2.h

mmk_m3$(EXE)			:	mmk_m3.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					mmk_m3.h

mord$(EXE)			:	mord.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\

=== doc/src/maint/Makefile ===
## Copyright 2018,2019,2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION		= 7.0

MMAN		= scotch_maint$(VERSION)

FLAGS		= -sPAPERSIZE=a4

DEPS		= $(wildcard *.tex) $(wildcard *.eps)

MANS		= $(MMAN).ps.gz $(MMAN).pdf

CP		= cp -f
RM		= rm -f

.PHONY				:	clean	default	install	realclean

default				:	$(MANS)

%.eps				:	%.fig
					fig2dev -L eps $(<) $(@)

%.dvi				:	%.tex $(DEPS)
					latex $(<)
					-bibtex $(*)
					latex $(<)
					latex $(<)

%.ps				:	%.dvi
					dvips $(FLAGS) $(<)

$(MMAN).pdf			:	m.dvi
					dvipdf $(FLAGS) $(<) $(@)

$(MMAN).ps.gz			:	m.ps
					gzip -9 -c < $(<) > $(@)

install				:	$(MANS)
					-$(CP) $(MMAN).ps.gz ../../
					-$(CP) $(MMAN).pdf ../../

clean				:
					-$(RM) *~ m.aux m.blg m.log m.out m.toc

realclean			:	clean
					-$(RM) *~ m.bbl *dvi m.ps $(MMAN)*

=== doc/src/ptscotch/Makefile ===
## Copyright 2018,2019 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION		= 7.0

UMAN		= ptscotch_user$(VERSION)

FLAGS		= -sPAPERSIZE=a4

DEPS		= $(wildcard *.tex) $(wildcard *.eps)

MANS		= $(UMAN).ps.gz $(UMAN).pdf

CP		= cp -f
RM		= rm -f

.PHONY				:	clean	default	install	realclean

default				:	$(MANS)

%.eps				:	%.fig
					fig2dev -L eps $(<) $(@)

%.dvi				:	%.tex $(DEPS)
					latex $(<)
					-bibtex $(*)
					latex $(<)
					latex $(<)

%.ps				:	%.dvi
					dvips $(FLAGS) $(<)

$(UMAN).pdf			:	p.dvi
					dvipdf $(FLAGS) $(<) $(@)

$(UMAN).ps.gz			:	p.ps
					gzip -9 -c < $(<) > $(@)

install				:	$(MANS)
					-$(CP) $(UMAN).ps.gz ../../
					-$(CP) $(UMAN).pdf ../../

clean				:
					-$(RM) *~ p.aux p.blg p.log p.out p.toc

realclean			:	clean
					-$(RM) *~ p.bbl *dvi $(UMAN)*

=== doc/src/scotch/Makefile ===
## Copyright 2018,2019,2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION		= 7.0

UMAN		= scotch_user$(VERSION)

FLAGS		= -sPAPERSIZE=a4

DEPS		= $(wildcard *.tex) $(wildcard *.eps)

MANS		= $(UMAN).ps.gz $(UMAN).pdf

CP		= cp -f
RM		= rm -f

.PHONY				:	clean	default	install	realclean

default				:	$(MANS)

%.eps				:	%.fig
					fig2dev -L eps $(<) $(@)

%.dvi				:	%.tex $(DEPS)
					latex $(<)
					-bibtex $(*)
					latex $(<)
					latex $(<)

%.ps				:	%.dvi
					dvips $(FLAGS) $(<)

$(UMAN).pdf			:	s.dvi
					dvipdf $(FLAGS) $(<) $(@)

$(UMAN).ps.gz			:	s.ps
					gzip -9 -c < $(<) > $(@)

install				:	$(MANS)
					-$(CP) $(UMAN).ps.gz ../../
					-$(CP) $(UMAN).pdf ../../

clean				:
					-$(RM) *~ s.aux s.blg s.log s.out s.toc

realclean			:	clean
					-$(RM) *~ s.bbl *dvi s.ps $(UMAN)*

=== debian/changelog ===
scotch (7.0.3-2) unstable; urgency=high

  * Team upload.
  * update libscotchmetis-dev and libscotchparmetis-dev links to point
    int-specific libmetis.so at the corresponding libscotchmetisv5.so
    (v5 not v3, to match libmetis), and point libparmetis.so at the
    corresponding int-build of libptscotchparmetisv3.so. Likewise for
    static .a libraries. Closes: #1036576.

 -- Drew Parsons <dparsons@debian.org>  Tue, 23 May 2023 17:23:49 +0200

scotch (7.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Mon, 06 Feb 2023 10:55:20 +0100

=== debian/control ===
Source: scotch
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper-compat (= 13),
    gfortran | fortran-compiler,
    bison, flex,
    zlib1g-dev,
    libbz2-dev,
    liblzma-dev,
    chrpath,
    mpi-default-dev, mpi-default-bin
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/science-team/scotch.git
Vcs-Browser: https://salsa.debian.org/science-team/scotch
Homepage: http://www.labri.fr/perso/pelegrin/scotch/

Package: scotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Its purpose is to apply graph theory, with a divide and conquer
 approach, to scientific computing problems such as graph and mesh
 partitioning, static mapping, and sparse matrix ordering, in
 application domains ranging from structural mechanics to operating
 systems or bio-chemistry.
 .
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 SCOTCH has many interesting features:
 .
 o Its capabilities can be used through a set of stand-alone programs
 as well as through the libSCOTCH library, which offers both C and
 Fortran interfaces.
 .
 o It provides algorithms to partition graph structures, as well as
 mesh structures defined as node-element bipartite graphs and which
 can also represent hypergraphs.
 .
 o It can map any weighted source graph onto any weighted target
 graph. The source and target graphs may have any topology, and their
 vertices and edges may be weighted. Moreover, both source and target
 graphs may be disconnected. This feature allows for the mapping of
 programs onto disconnected subparts of a parallel architecture made
 up of heterogeneous processors and communication links.
 .
 o It computes amalgamated block orderings of sparse matrices, for
 efficient solving using BLAS routines.
 .
 o Its running time is linear in the number of edges of the source
 graph, and logarithmic in the number of vertices of the target graph
 for mapping computations.
 .
 o It can handle indifferently graph and mesh data structures created
 within C or Fortran programs, with array indices starting from 0 or
 1.
 .
 o It offers extended support for adaptive graphs and meshes through
 the handling of disjoint edge arrays.
 .
 o It is dynamically parametrizable thanks to strategy strings that
 are interpreted at run-time.
 .
 o It uses system memory efficiently, to process large graphs and
 meshes without incurring out-of-memory faults;
 .
 o It is highly modular and documented. Since it has been released
 under the CeCILL-C free/libre software license, it can be used as a
 testbed for the easy and quick development and testing of new
 partitioning and ordering methods.
 .
 o It can be easily interfaced to other programs. The programs
 comprising the SCOTCH project have been designed to run in
 command-line mode without any interactive prompting, so that they can
 be called easily from other programs by means of system() or popen()
 calls, or piped together on a single command line. Moreover, vertex
 labeling capabilities allow for easy renumbering of vertices.
 .
 o It provides many tools to build, check, and display graphs, meshes
 and matrix patterns.
 .
 o It is written in C and uses the POSIX interface, which makes it
 highly portable. PT-SCOTCH uses the MPI interface, and optionally the
 POSIX threads.

Package: ptscotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libscotch-dev
Section: libdevel
Architecture: any
Depends: libscotch-7.0 (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-dev
Section: libdevel
Architecture: any
Depends: libptscotch-7.0 (= ${binary:Version}), libscotch-dev (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: libscotchmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libmetis-dev, libparmetis-dev
Replaces: libmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/Metis compatility interface, providing a free implementation of the
 Metis system for graph partitioning and sparse matrix reordering.

Package: libscotchparmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libparmetis-dev
Replaces: libparmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/ParMetis compatility interface, providing a free implementation of the
 ParMetis system for parallel graph partitioning and sparse matrix reordering.

Package: libscotch-7.0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-7.0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1


DEB_BUILD_ARCH_OS ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Disabled because this FTBFS with multiple jobs (bug 620973)
#ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#         MAKEFLAGS += -j$(NUMJOBS)
#endif

# Add here any variable or target overrides you need.
# where sources are
DEB_SRCDIR = $(CURDIR)/src

# no check for this software
#DEB_MAKE_CHECK_TARGET :=

# note that debian patch default_metis_v5.patch
# has set metis version compatibility to 5
# (SCOTCH_METIS_VERSION=5) in metis.h (library_metis.h),
# equivalent to configuring the build with -DSCOTCH_METIS_VERSION=5

CCP=mpicc
export CFLAGS_COMMON = -O3 -fPIC -I. \
			-Drestrict=__restrict \
			-DCOMMON_FILE_COMPRESS_GZ \
			-DCOMMON_FILE_COMPRESS_BZ2 \
			-DCOMMON_FILE_COMPRESS_LZMA \
			-DSCOTCH_PTHREAD -DCOMMON_PTHREAD \
			-DSCOTCH_PTHREAD_NUMBER=2 \
			-DCOMMON_PTHREAD_FILE \
			-DSCOTCH_PTHREAD_MPI \
			-DCOMMON_RANDOM_FIXED_SEED \
			-DSCOTCH_RENAME -DSCOTCH_RENAME_PARSER \
			$(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS_COMMON = -pthread -lz -lbz2 -llzma -lm -lrt $(shell dpkg-buildflags --get LDFLAGS)

# hurd does not have POSIX time and therefore needs sys/time.h to define struct timeval
# hurd does not support pthread_setaffinity_np (-DSCOTCH_PTHREAD_AFFINITY_LINUX)
ifeq ($(DEB_BUILD_ARCH_OS),hurd)
  CFLAGS_COMMON += -DHAVE_SYS_TIME_H
else
  CFLAGS_COMMON += -DCOMMON_PTHREAD_AFFINITY_LINUX
endif

# By default, halt on test (check) failures. But,
# - hurd times out on buildd during build-time checks
# - m68k segfaults inside the qemu emulator used for builds
# - powerpcspe segfaults on test_scotch_graph_order in INTSIZE64
# so don't halt on test failures on these arches.
# In fact don't run tests at all on hurd.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
  HALT_ON_TEST_ERROR = no
  SKIP_TESTS = yes
else ifeq ($(DEB_HOST_ARCH),m68k)
  HALT_ON_TEST_ERROR = no
else ifeq ($(DEB_HOST_ARCH),powerpcspe)
  HALT_ON_TEST_ERROR = no
else
  HALT_ON_TEST_ERROR = yes
endif
ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  SKIP_TESTS = yes
endif


DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')
SCOTCH_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)

INTSIZE_VERS := $(shell echo "int int32 int64 long")

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

%:
	dh $@

override_dh_auto_configure:
	echo "Using preconfigured Makefile.inc."

override_dh_auto_build:
	for v in $(INTSIZE_VERS); do \
	   mkdir -p $(CURDIR)/$$v; \
	   mkdir -p $(CURDIR)/$$v/bin; \
	   mkdir -p $(CURDIR)/$$v/lib; \
	   mkdir -p $(CURDIR)/$$v/include; \
	   mkdir -p $(CURDIR)/$$v/share/man/man1; \
	done
	set -e; \
	for v in $(INTSIZE_VERS); do \
	   echo "compiling for $$v"; \
	   cp debian/Makefile_$$v.inc src/Makefile.inc; \
	   (cd src && $(MAKE) realclean prefix=$(CURDIR)/$$v); \
	   (cd src && $(MAKE) scotch ptscotch prefix=$(CURDIR)/$$v); \
	   (cd src && $(MAKE) esmumps ptesmumps prefix=$(CURDIR)/$$v); \
	   echo "check for $$v"; \
	   if [ "x$(SKIP_TESTS)" != "xyes" ]; then \
	     if [ "x$(HALT_ON_TEST_ERROR)" = "xno" ]; then \
	       (cd src && LD_LIBRARY_PATH=$(CURDIR)/src/check/../../lib:$(LD_LIBRARY_PATH) $(MAKE) check prefix=$(CURDIR)/$$v) || /bin/true; \
	     else \
	       (cd src && LD_LIBRARY_PATH=$(CURDIR)/src/check/../../lib:$(LD_LIBRARY_PATH) $(MAKE) check prefix=$(CURDIR)/$$v); \
	     fi; \
	   fi; \
	   echo "install for $$v"; \
	   (cd src && $(MAKE) install prefix=$(CURDIR)/$$v); \
	   mv $$v/bin/gbase $$v/bin/scotch_gbase; \
	   mv $$v/bin/gmap $$v/bin/scotch_gmap; \
	   mv $$v/bin/gpart $$v/bin/scotch_gpart; \
	   rm -rf lib; \
	   rm -f src/Makefile.inc; \
	done

override_dh_auto_install:
#	find . -name libscotch.so | xargs ls -l; \
#	Install [par]metis-compatibility symlinks
	for v in $(INTSIZE_VERS); do \
	   (cd $$v/lib && ln -s libscotchmetisv5.a libmetis.a); \
	   (cd $$v/lib && ln -s libscotchmetisv5.so libmetis.so); \
	   (cd $$v/lib && ln -s libptscotchparmetisv3.a libparmetis.a); \
	   (cd $$v/lib && ln -s libptscotchparmetisv3.so libparmetis.so); \
	done

#	add suffix to {int32,int64,long}/bin/*
	for file in $(shell ls int32/bin); do \
	   (cd int32/bin && mv $$file $$file-int32); \
	done
	for file in $(shell ls int64/bin); do \
	   (cd int64/bin && mv $$file $$file-int64); \
	done
	for file in $(shell ls long/bin); do \
	   (cd long/bin && mv $$file $$file-long); \
	done
#       Add "#include <cstdio>" to main [pt]scotch.h
	find . -name \*scotch.h | xargs perl -pi -e "s|\/\*\+ Version flags|\#ifdef \_\_cplusplus\n\#include \<cstdio\>\n\#else\n\#include \<stdio.h\>\n\#endif\n\n\/\*\+ Version flags|"


override_dh_installman:
	dh_installman
	mv debian/scotch/usr/share/man/man1/gmap.1 debian/scotch/usr/share/man/man1/scotch_gmap.1
	mv debian/scotch/usr/share/man/man1/gbase.1 debian/scotch/usr/share/man/man1/scotch_gbase.1
	(cd debian/scotch/usr/share/man/man1 && ln -sf scotch_gmap.1.gz scotch_gpart.1.gz)
	for file in $(shell ls int/bin); do \
	  if [ -x debian/scotch/usr/bin/$$file ]; then \
	    (cd debian/scotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int32.1.gz); \
	    (cd debian/scotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int64.1.gz); \
	    (cd debian/scotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-long.1.gz); \
	  fi; \
	  if [ -x debian/ptscotch/usr/bin/$$file ]; then \
	    (cd debian/ptscotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int32.1.gz); \
	    (cd debian/ptscotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int64.1.gz); \
	    (cd debian/ptscotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-long.1.gz); \
	  fi; \
	done


override_dh_clean:
	dh_clean
	for v in $(INTSIZE_VERS); do \
	   (if [ -d $$v ]; then rm -rf $$v; fi); \
	done
	cp debian/Makefile.inc src/
	make -C src/check realclean
	make -C src realclean
	rm -f src/Makefile.inc
